///home/berryj/link/bin/genMethods "-g" "-t" "Edge*" "-h" "Set" "-r" "MSet<Edge*>" "-I" "LINK/basic/Set.h" "-I" "LINK/graph/Edge.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Edge* _Edge_;
typedef Set<Edge* > _Set_Edge__;
static Set<Edge* > s__Set_Edge__;

#define _Set_Edge__DATA(x) ((Set<Edge* >*) (EXTDATA(x)))
#define _Set_Edge__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<Edge* > >::type))
#define _Set_Edge__ISNT_DATA(x) (!_Set_Edge__IS_DATA(x))

#define _Set_Edge__CXX_DATA(x) (*(Set<Edge* >*) (EXTDATA(VAL(x))))
#define _Set_Edge__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<Edge* > >::type))
#define _Set_Edge__CXX_ISNT_DATA(x) (!_Set_Edge__CXX_IS_DATA(x))


PRIMITIVE STk_init__Set_Edge__()
{
	Wrapper<_Set_Edge__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Set_Edge__>::name, 
			Wrapper<MSet<Edge*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Edge_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Set_Edge__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Set_Edge__Methods(void);

PRIMITIVE STk_init_methods__Set_Edge__()
{
	genExtra_Set_Edge__Methods();
	return UNDEFINED;
}
